# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1.Model.ExportContextSqlExportOptionsMysqlExportOptions do
  @moduledoc """
  Options for exporting from MySQL.

  ## Attributes

  *   `masterData` (*type:* `integer()`, *default:* `nil`) - Option to include SQL statement required to set up replication. If set to `1`, the dump file includes a CHANGE MASTER TO statement with the binary log coordinates, and --set-gtid-purged is set to ON. If set to `2`, the CHANGE MASTER TO statement is written as a SQL comment and has no effect. If set to any value other than `1`, --set-gtid-purged is set to OFF.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :masterData => integer() | nil
        }

  field(:masterData)
end

defimpl Poison.Decoder,
  for: GoogleApi.SQLAdmin.V1.Model.ExportContextSqlExportOptionsMysqlExportOptions do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1.Model.ExportContextSqlExportOptionsMysqlExportOptions.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.SQLAdmin.V1.Model.ExportContextSqlExportOptionsMysqlExportOptions do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
