# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1.Model.UserPasswordValidationPolicy do
  @moduledoc """
  User level password validation policy.

  ## Attributes

  *   `allowedFailedAttempts` (*type:* `integer()`, *default:* `nil`) - Number of failed login attempts allowed before user get locked.
  *   `enableFailedAttemptsCheck` (*type:* `boolean()`, *default:* `nil`) - If true, failed login attempts check will be enabled.
  *   `enablePasswordVerification` (*type:* `boolean()`, *default:* `nil`) - If true, the user must specify the current password before changing the password. This flag is supported only for MySQL.
  *   `passwordExpirationDuration` (*type:* `String.t`, *default:* `nil`) - Expiration duration after password is updated.
  *   `status` (*type:* `GoogleApi.SQLAdmin.V1.Model.PasswordStatus.t`, *default:* `nil`) - Output only. Read-only password status.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :allowedFailedAttempts => integer() | nil,
          :enableFailedAttemptsCheck => boolean() | nil,
          :enablePasswordVerification => boolean() | nil,
          :passwordExpirationDuration => String.t() | nil,
          :status => GoogleApi.SQLAdmin.V1.Model.PasswordStatus.t() | nil
        }

  field(:allowedFailedAttempts)
  field(:enableFailedAttemptsCheck)
  field(:enablePasswordVerification)
  field(:passwordExpirationDuration)
  field(:status, as: GoogleApi.SQLAdmin.V1.Model.PasswordStatus)
end

defimpl Poison.Decoder, for: GoogleApi.SQLAdmin.V1.Model.UserPasswordValidationPolicy do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1.Model.UserPasswordValidationPolicy.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.SQLAdmin.V1.Model.UserPasswordValidationPolicy do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
