# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1beta4.Model.AcquireSsrsLeaseContext do
  @moduledoc """
  Acquire SSRS lease context.

  ## Attributes

  *   `duration` (*type:* `String.t`, *default:* `nil`) - Lease duration needed for the SSRS setup.
  *   `reportDatabase` (*type:* `String.t`, *default:* `nil`) - The report database to be used for the SSRS setup.
  *   `serviceLogin` (*type:* `String.t`, *default:* `nil`) - The username to be used as the service login to connect to the report database for SSRS setup.
  *   `setupLogin` (*type:* `String.t`, *default:* `nil`) - The username to be used as the setup login to connect to the database server for SSRS setup.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :duration => String.t() | nil,
          :reportDatabase => String.t() | nil,
          :serviceLogin => String.t() | nil,
          :setupLogin => String.t() | nil
        }

  field(:duration)
  field(:reportDatabase)
  field(:serviceLogin)
  field(:setupLogin)
end

defimpl Poison.Decoder, for: GoogleApi.SQLAdmin.V1beta4.Model.AcquireSsrsLeaseContext do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1beta4.Model.AcquireSsrsLeaseContext.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.SQLAdmin.V1beta4.Model.AcquireSsrsLeaseContext do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
