# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1beta4.Model.DatabaseInstanceFailoverReplica do
  @moduledoc """
  The name and status of the failover replica.

  ## Attributes

  *   `available` (*type:* `boolean()`, *default:* `nil`) - The availability status of the failover replica. A false status indicates that the failover replica is out of sync. The primary instance can only failover to the failover replica when the status is true.
  *   `name` (*type:* `String.t`, *default:* `nil`) - The name of the failover replica. If specified at instance creation, a failover replica is created for the instance. The name doesn't include the project ID.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :available => boolean() | nil,
          :name => String.t() | nil
        }

  field(:available)
  field(:name)
end

defimpl Poison.Decoder, for: GoogleApi.SQLAdmin.V1beta4.Model.DatabaseInstanceFailoverReplica do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1beta4.Model.DatabaseInstanceFailoverReplica.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.SQLAdmin.V1beta4.Model.DatabaseInstanceFailoverReplica do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
