# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1beta4.Model.ImportContextBakImportOptionsEncryptionOptions do
  @moduledoc """


  ## Attributes

  *   `certPath` (*type:* `String.t`, *default:* `nil`) - Path to the Certificate (.cer) in Cloud Storage, in the form `gs://bucketName/fileName`. The instance must have write permissions to the bucket and read access to the file.
  *   `pvkPassword` (*type:* `String.t`, *default:* `nil`) - Password that encrypts the private key
  *   `pvkPath` (*type:* `String.t`, *default:* `nil`) - Path to the Certificate Private Key (.pvk) in Cloud Storage, in the form `gs://bucketName/fileName`. The instance must have write permissions to the bucket and read access to the file.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :certPath => String.t() | nil,
          :pvkPassword => String.t() | nil,
          :pvkPath => String.t() | nil
        }

  field(:certPath)
  field(:pvkPassword)
  field(:pvkPath)
end

defimpl Poison.Decoder,
  for: GoogleApi.SQLAdmin.V1beta4.Model.ImportContextBakImportOptionsEncryptionOptions do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1beta4.Model.ImportContextBakImportOptionsEncryptionOptions.decode(
      value,
      options
    )
  end
end

defimpl Poison.Encoder,
  for: GoogleApi.SQLAdmin.V1beta4.Model.ImportContextBakImportOptionsEncryptionOptions do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
