# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1beta4.Model.SqlExternalSyncSettingError do
  @moduledoc """
  External primary instance migration setting error/warning.

  ## Attributes

  *   `detail` (*type:* `String.t`, *default:* `nil`) - Additional information about the error encountered.
  *   `kind` (*type:* `String.t`, *default:* `nil`) - Can be `sql#externalSyncSettingError` or `sql#externalSyncSettingWarning`.
  *   `type` (*type:* `String.t`, *default:* `nil`) - Identifies the specific error that occurred.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :detail => String.t() | nil,
          :kind => String.t() | nil,
          :type => String.t() | nil
        }

  field(:detail)
  field(:kind)
  field(:type)
end

defimpl Poison.Decoder, for: GoogleApi.SQLAdmin.V1beta4.Model.SqlExternalSyncSettingError do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1beta4.Model.SqlExternalSyncSettingError.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.SQLAdmin.V1beta4.Model.SqlExternalSyncSettingError do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
