# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1beta4.Model.SqlOutOfDiskReport do
  @moduledoc """
  This message wraps up the information written by out-of-disk detection job.

  ## Attributes

  *   `sqlMinRecommendedIncreaseSizeGb` (*type:* `integer()`, *default:* `nil`) - The minimum recommended increase size in GigaBytes This field is consumed by the frontend * Writers: * the proactive database wellness job for OOD. * Readers:
  *   `sqlOutOfDiskState` (*type:* `String.t`, *default:* `nil`) - This field represents the state generated by the proactive database wellness job for OutOfDisk issues. * Writers: * the proactive database wellness job for OOD. * Readers: * the proactive database wellness job
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :sqlMinRecommendedIncreaseSizeGb => integer() | nil,
          :sqlOutOfDiskState => String.t() | nil
        }

  field(:sqlMinRecommendedIncreaseSizeGb)
  field(:sqlOutOfDiskState)
end

defimpl Poison.Decoder, for: GoogleApi.SQLAdmin.V1beta4.Model.SqlOutOfDiskReport do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1beta4.Model.SqlOutOfDiskReport.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.SQLAdmin.V1beta4.Model.SqlOutOfDiskReport do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
