# Copyright 2019 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# NOTE: This file is auto generated by the elixir code generator program.
# Do not edit this file manually.

defmodule GoogleApi.SQLAdmin.V1beta4.Model.SqlServerAuditConfig do
  @moduledoc """
  SQL Server specific audit configuration.

  ## Attributes

  *   `bucket` (*type:* `String.t`, *default:* `nil`) - The name of the destination bucket (e.g., gs://mybucket).
  *   `kind` (*type:* `String.t`, *default:* `nil`) - This is always sql#sqlServerAuditConfig
  *   `retentionInterval` (*type:* `String.t`, *default:* `nil`) - How long to keep generated audit files.
  *   `uploadInterval` (*type:* `String.t`, *default:* `nil`) - How often to upload generated audit files.
  """

  use GoogleApi.Gax.ModelBase

  @type t :: %__MODULE__{
          :bucket => String.t() | nil,
          :kind => String.t() | nil,
          :retentionInterval => String.t() | nil,
          :uploadInterval => String.t() | nil
        }

  field(:bucket)
  field(:kind)
  field(:retentionInterval)
  field(:uploadInterval)
end

defimpl Poison.Decoder, for: GoogleApi.SQLAdmin.V1beta4.Model.SqlServerAuditConfig do
  def decode(value, options) do
    GoogleApi.SQLAdmin.V1beta4.Model.SqlServerAuditConfig.decode(value, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.SQLAdmin.V1beta4.Model.SqlServerAuditConfig do
  def encode(value, options) do
    GoogleApi.Gax.ModelBase.encode(value, options)
  end
end
